/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 0.82B */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "globals.h"
#include "abimport.h"
#include "proto.h"

int
inc_0( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{
	PhArea_t		area;
	PtArg_t			args[2];

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	if ( !raw_wgt ) {
		area.pos.x = area.pos.y = 0;
		area.size.w = 1024;
		area.size.h = 768;
		PtSetArg( &args[0], Pt_ARG_AREA, &area, 0 );
		PtSetArg( &args[1], Pt_ARG_RAW_DRAW_F, base_expose, 0 );
		PtRealizeWidget( raw_wgt = PtCreateWidget( PtRaw, ABW_sscreen, 2, args ) );
		ApClearWidget( ABW_spane );
		PtReRealizeWidget( ABW_spane );
		}

	scroll_inc = 768;

	return( Pt_CONTINUE );

	}

int
inc_1( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	scroll_inc = 8;

	if ( raw_wgt ) {
		PtDestroyWidget( raw_wgt );
		raw_wgt = NULL;
		screen_update( ABW_spane, slide_curr, 0 );
		}

	return( Pt_CONTINUE );

	}

int
inc_2( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	scroll_inc = 16;

	if ( raw_wgt ) {
		PtDestroyWidget( raw_wgt );
		raw_wgt = NULL;
		screen_update( ABW_spane, slide_curr, 0 );
		}

	return( Pt_CONTINUE );

	}

int
inc_3( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	scroll_inc = 32;

	if ( raw_wgt ) {
		PtDestroyWidget( raw_wgt );
		raw_wgt = NULL;
		screen_update( ABW_spane, slide_curr, 0 );
		}

	return( Pt_CONTINUE );

	}

int
inc_4( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	scroll_inc = 64;

	if ( raw_wgt ) {
		PtDestroyWidget( raw_wgt );
		raw_wgt = NULL;
		screen_update( ABW_spane, slide_curr, 0 );
		}

	return( Pt_CONTINUE );

	}

