/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 0.80B */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "abimport.h"
#include "globals.h"
#include "proto.h"

int
screen_setup( PtWidget_t *link_instance, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{

	/* eliminate 'unreferenced' warnings */
	link_instance = link_instance, apinfo = apinfo, cbinfo = cbinfo;

	return( Pt_CONTINUE );

	}

int
screen_select( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{
	PhPointerEvent_t	*pdata;

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	pdata = PhGetData( cbinfo->event );	

	if ( pdata->buttons == 1 )
		screen_prev( widget, apinfo, cbinfo );
	else
		screen_next( widget, apinfo, cbinfo );

	return( Pt_CONTINUE );

	}

int
screen_prev( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	/* haven't started yet... */
	if ( slide_curr == -1 )
		return( Pt_CONTINUE );

	/* get previous slide */
	if ( slide_curr != 0 )
		screen_update( ABW_sscreen, --slide_curr, 1 );

	/* read previous slide */
	if ( slide_curr != 0 )
		screen_read( slide_curr - 1 );

	/* free slide 2 ahead */
	if ( slide_curr < slide_ctr - 2 ) 
		screen_free( slide_curr + 2 );

	return( Pt_CONTINUE );

	}

int
screen_next( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	/* display next slide */
	if ( slide_curr < slide_ctr - 1 )
		screen_update( ABW_sscreen, ++slide_curr, 1 );

	/* read next slide */
	if ( slide_curr != slide_ctr - 1 )
		screen_read( slide_curr + 1 );

	/* free slide 2 back */
	if ( slide_curr > 1 )
		screen_free( slide_curr - 2 );

	return( Pt_CONTINUE );

	}

void
screen_update( PtWidget_t *parent, int slide_no, int palette )

	{
	int			n = 0;
	PtArg_t		args[3];
	PhImage_t	*i, img;

	/* not ready */
	if ( slide_no == -1 )
		return;
	
	/* make life easier */
	i = images[slide_no];
	memset( sh_image, 0, 1024 * 768 );
	memcpy( sh_image, i->image, i->size.h * i->size.w );

	img = *i;
	img.image = sh_image;

	if ( img.size.h == 768 && img.size.w == 1024 ) {
		PtSetArg( &args[n], Pt_ARG_FILL_COLOR, Pg_TRANSPARENT, 0 ); n++;
		}
	else {
		PtSetArg( &args[n], Pt_ARG_FILL_COLOR, Pg_BLACK, 0 ); n++;
		}
	PtSetArg( &args[n], Pt_ARG_LABEL_TYPE, Pt_IMAGE, Pt_IMAGE ); n++;
	PtSetArg( &args[n], Pt_ARG_LABEL_DATA, &img, sizeof( PhImage_t ) ); n++;
	PtSetResources( ABW_sscreen, n, args );
	PtFlush( );

	}

void
screen_read( int slide_no )

	{
	char		path[PATH_MAX];
	PxMethods_t methods;

	/* resolve path offset */
	if ( slides[slide_no][0] == '/' )
		strcpy( path, slides[slide_no] );
	else {
		strcpy( path, slide_path );
		strcat( path, "/" );
		strcat( path, slides[slide_no] );
		}
	
	memset( &methods, 0, sizeof( PxMethods_t ) );
	methods.flags |= PX_LOAD;
	if ( ( images[slide_no] = PxLoadImage( path, &methods ) ) == NULL )
		return;

	}

void
screen_free( int slide_no )

	{

	if ( !images[slide_no] )
		return;

	if ( images[slide_no]->palette ) {
		free( images[slide_no]->palette );
		images[slide_no]->palette = NULL;
		}

	if ( images[slide_no]->image ) {
		free( images[slide_no]->image );
		images[slide_no]->image = NULL;
		}

	free( images[slide_no] );
	images[slide_no] = NULL;

	}


